# Overview
These scripts are used for building the solution with Jenkins on a Windows machine.

Jenkins will run `build_as_config.cmd` and `package.cmd`.

# Implementation

## [`build_as_config.cmd`](build_as_config.cmd)
Run `config.cmd`, `build.cmd`, and `test.cmd`, in that order.  If any fail, this command file fails.

## [`config.cmd`](config.cmd)
Set all environment variables that are needed for `build.cmd`.
 + `SLN_PATH` Path of the solution file. Since Jenkins will run the script in the root folder of the repository, it should use the current path.
 + `SLN_NAME` Name of the solution file without suffix.
 + `UNITTEST_NAME` Name of the unit test project without suffix.

## [`build.cmd`](build.cmd)
Build all platforms and configurations.

## [`test.cmd`](test.cmd)
Run unit tests.

## [`package.cmd`](test.cmd)
Package outputs into a Zip file, including the files in the Mac-Jenkins-created Zip file.  This assumes the Mac Jenkins job completes before the Windows Jenkins job.
